%{
#include <stdio.h>
%}

%token TRANSACTION READ WRITE ID NUMBER DONE LOCK READLOCK WRITELOCK UNLOCK

%%

scenario : setcommands transactions DONE { printf("*** Klart! ***\n"); } ;

transactions : transaction transactions | /* empty */ ;

transaction : TRANSACTION ID '{' anycommands '}' ;

anycommands : anycommand anycommands | /* empty */ ;

anycommand : setcommand | dbcommand | lockcommand ;

setcommands : setcommand setcommands | /* empty */ ;

setcommand : ID '=' expression ';' ;

dbcommand : READ '(' ID ')' ';' | WRITE '(' ID ')' ';' ;

lockcommand : LOCK '(' ID ')' ';' | READLOCK '(' ID ')' ';' | WRITELOCK '(' ID ')' ';' | UNLOCK '(' ID ')' ';' ;

expression : term moreterms ;

moreterms : '+' term moreterms | '-' term moreterms | /* empty */ ;

term : factor morefactors ;

morefactors : '*' factor morefactors | '/' factor morefactors | '%' factor morefactors | /* empty */ ;

factor : NUMBER | ID | '(' expression ')' ;
       
%%

